;send bug fixes to dug@forestnet.org
.386
locals
jumps
.model flat,STDCALL

extrn   FindWindowA     :Proc
extrn   MessageBoxA     :Proc
extrn   SendMessageA    :Proc
extrn   LoadLibraryA    :Proc
extrn   GetProcAddress  :Proc
extrn   CreateProcessA  :Proc
extrn   GetLastError    :Proc
extrn   ResumeThread    :Proc
extrn   GetWindowLongA  :Proc
extrn   ShowWindow      :Proc

.data
cname                   db "foobarr plugin error ",00h,"       ",00h
errloadlib              db "can't load lsapi.dll",00h
errGPA                  db "can't resolve 'AddBangCommandEx' simbol",00h
errGPA2                 db "can't resolve 'GetRCStringEx' simbol",00h
errproc                 db "can't start foobar process",00h
errfnf                  db "The system cannot find the file specified.",00h

fbclass                 db "frw_cls",00h
libname                 db "lsapi.dll",00h
addprocname             db "AddBangCommand",00h
getprocname             db "GetRCString",00h;

bngplaypause            db "!foo_playpause",00h
bngnext                 db "!foo_next",00h
bngnextrand             db "!foo_nextrand",00h
bngshuffle              db "!foo_shuffle",00h
bngprev                 db "!foo_prev",00h
bngshow                 db "!foo_show",00h
bngloaddir              db "!foo_loaddir",00h
bngrew5s                db "!foo_rewd5s",00h
bngffwd5s               db "!foo_ffwd5s",00h
bngvolumeup             db "!foo_volumeup",00h
bngvolumedown           db "!foo_volumedown",00h


bngplay                 db 01,"!foo_play",00            ;PLAYBACK_PLAY

deffoobarlocation       db "C:\Program Files\foobar\foobar2000.exe",00h
foobarlocationopt       db "FoobarPath",00h

cfname                  db "can't find procaddr",00h ; ???
tryagainflag            db 0


OnTop                   dd 1
STARTUPINFO             dd 18, 17 dup (0)
PROCESS_INFORMATION     dd 4 dup (?)
libaddr                 dd ?              
curpos                  dd ?
totallen                dd ?
GetRCString             dd ?
AddBangCommandEx        dd ?
foobarlocation          db 256 dup (?)

.code
Start:

dll     proc    instance:DWORD, reason:DWORD, reserved:DWORD
        mov     eax,1
        ret
endp    dll

initModuleEx    proc    ;parent:DWORD, dllInst:DWORD, path:DWORD
        push    offset libname
        call    LoadLibraryA
        test    eax,    eax
        jnz     no_loading_error
        lea     ebx,    errloadlib
        call    error
        ret
no_loading_error:
        mov     libaddr,eax
        push    offset getprocname
        push    eax
        call    GetProcAddress
        test    eax,    eax
        jnz     found_addr
        lea     ebx,    errGPA2
        call    error
        xor     eax,    eax
        ret
found_addr:
        mov     GetRCString,eax
        push    offset addprocname
        mov     eax,    libaddr
        push    eax
        call    GetProcAddress
        test    eax,eax
        jnz     found_addr2
        lea     ebx,    errGPA
        call    error
        ret
found_addr2:
        mov     AddBangCommandEx, eax
        push    offset bangplaypause
        push    offset bngplaypause
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangnext
        push    offset bngnext
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangnextrand
        push    offset bngnextrand
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangprev
        push    offset bngprev
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangshow
        push    offset bngshow
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangrew5s
        push    offset bngrew5s
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangloaddir
        push    offset bngloaddir
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangshuffle
        push    offset bngshuffle
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangffwd5s
        push    offset bngffwd5s
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangvolumeup
        push    offset bngvolumeup
        call    AddBangCommandEx
        add     esp,    8
        push    offset bangvolumedown
        push    offset bngvolumedown
        call    AddBangCommandEx
        add     esp,    8
        xor     eax,    eax
        ret
endp 

quitModule      proc    ;dllInst:DWORD
        ret
endp 

bangplaypause    proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_playpause
        push    0
        push    4 ;PLAYBACK_PLAY_PAUSE
        push    1025
        push    eax
        call    SendMessageA
        jmp     hurray
nownd_playpause:

;CreateProcessCreateProcessCreateProcessCreateProcessCreateProcessCreateProcess

        push    255
        push    offset deffoobarlocation
        push    offset foobarlocation
        push    offset foobarlocationopt
        call    GetRCString

        push    offset PROCESS_INFORMATION                 ;PROCESSINFO
        push    offset STARTUPINFO      ;STARTUPINFO
        xor     eax,    eax
        push    eax                     ;cur dir
        push    eax                     ;new env
        push    eax                     ;creation flags
        push    eax                     ;inheritance flag
        push    eax                     ;pointer to thread security attributes
        push    eax                     ;pointer to process security attributes
        push    eax                     ;params
        push    offset foobarlocation   ;command 
        call    CreateProcessA
        test    eax,    eax
        jnz     hurray
        
        call    GetLastError
        cmp     eax,2
        jnz     filenf

        push    0
        push    offset errfnf
        push    offset foobarlocation
        push    0
        call    MessageBoxA
        jmp     hurray
filenf:
        lea     ebx,    errproc
        call    erroreax
;teProcessCreateProcessCreateProcessCreateProcessCreateProcessCreateProcessCreateProcess
hurray:
        ret
endp 

bangprev        proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_prev
        push    0
        push    15                      ;PLAYBACK_PREV
        push    1025
        push    eax
        call    SendMessageA
nownd_prev:
        ret
endp 

bangnext        proc;CallerHWND:DWORD, Args:DWORD 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_next
        push    0
        push    2                       ;PLAYBACK_NEXT
        push    1025
        push    eax
        call    SendMessageA
nownd_next:
        ret    
endp 

bangrew5s       proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_rew5s
        push    -5
        push    18                      ;PLAYBACK_SEEK_DELTA
        push    1028                    ;FRC_SET_LONG
        push    eax
        call    SendMessageA
nownd_rew5s:
        ret
endp 

bangffwd5s       proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_ffwd5s
        push    eax
        push    eax
        push    0
        push    17                      ;PLAYBACK_GETLENGTH
        push    1027                    ;1027 = FRC_QUERY_LONG
        push    eax
        call    SendMessageA
        mov     ebx,    eax
        pop     eax
        push    offset curpos
        push    13                      ;PLAYBACK_GETPOS
        push    1027                    ;1027 = FRC_QUERY_LONG
        push    eax
        call    SendMessageA

        sub     ebx,    eax             ;till the end
        mov     ecx,    eax
        add     ecx,    5               ;should I check for overload? :)
        pop     eax
        cmp     ebx,    5
        jna     ignore     

        push    ecx
        push    12                      ;PLAYBACK_SEEK
        push    1028                    ;FRC_SET_LONG
        push    eax
        call    SendMessageA
nownd_ffwd5s:
ignore:
        ret
endp 

bangshow        proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_show
        cmp     OnTop,  0
        jnz     hideit
        push    0
        push    40                      ;WINDOW_BRING_TO_FRONT
        push    1025
        push    eax
        call    SendMessageA
        inc     OnTop
        jmp     exit_show
hideit:
        push    0
        push    41                      ;WINDOW_HIDE
        push    1025
        push    eax
        call    SendMessageA
        mov     OnTop,  0
nownd_show:
exit_show:
        ret
endp 


bangvolumeup    proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_volumeup
        push    0
        push    19                      ;VOLUME_UP
        push    1025
        push    eax
        call    SendMessageA
nownd_volumeup:
        ret
endp 

bangvolumedown  proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_volumedown
        push    0
        push    20                      ;VOLUME_DOWN
        push    1025
        push    eax
        call    SendMessageA
nownd_volumedown:
        ret
endp 

bangloaddir     proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_loaddir
        push    0
        push    28                     ;PLAYLIST_ADDDIRECTORY
        push    1025
        push    eax
        call    SendMessageA
nownd_loaddir:
        ret
endp 

bangshuffle     proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_shuffle
        mov     ebx,    eax
        push    -1
        push    8                     ;PLAYBACK_SHUFFLE
        push    1025
        push    eax
        call    SendMessageA
        
        xor     al,     1
        push    eax
        push    8                     ;PLAYBACK_SHUFFLE
        push    1025
        push    ebx
        call    SendMessageA
nownd_shuffle:
        ret
endp 

bangnextrand    proc 
        push    0
        push    offset fbclass
        call    FindWindowA
        test    eax,    eax
        jz      nownd_nextrand
        push    0
        push    3                     ;PLAYBACK_NEXT_RAND
        push    1025
        push    eax
        call    SendMessageA
nownd_nextrand:
        ret
endp 



printEAX proc
        push    eax
        rol     eax,    8
        call    printh
        add     dx,     2
        rol     eax,    8
        call    printh
        add     dx,     2
        rol     eax,    8
        call    printh
        add     dx,     2
        rol     eax,    8
        call    printh
        add     dx,     2

        pop     eax
        ret
endp
printh PROC
       PUSH    eAX
       PUSH    eDX
       MOV     AH,     AL
       AND     AH,     0Fh
       SHR     AL,     04
       CMP     AL,     09
       JNA     LOW_OK
       ADD     AL,     "A"-"9"-1
LOW_OK:
       CMP     AH,     09
       JNA     HIGH_OK
       ADD     AH,     "A"-"9"-1
HIGH_OK:
       ADD     AX,     "00"
       pop     edx
       mov     [edx],   al
       MOV     AL,      AH
       mov     [edx+1],   al
       POP     eAX
       RET
ENDP

erroreax proc; it does NOT safe for EAX!
         mov edx, offset cname+21
         call    printEAX
error    proc
         push    0
         push    offset cname
         push    ebx
         push    0
         call    MessageBoxA
         ret
endp
endp


PUBLICDLL   initModuleEx
PUBLICDLL   quitModule
End Start